"use strict";

if (typeof window.markets !== "function") {
  // Not initialized

  // Initialize of the class in global namespace
  window.markets = class markets {
    /**
     * Сгенерировать список
     *
     * @return {array|null} Массив HTML-элементов <option>
     */
    static async list() {
      // Запрос к серверу
      return await fetch(`/markets/list`, {
        method: "POST",
        headers: {
          "Content-Type": "application/x-www-form-urlencoded",
        },
      })
        .then((response) => response.text())
        .then((data) => {
          if (data.length > 0) {
						// Получены данные
            
						return data;
          }

					return null;
        });
    }
  };
}

// Вызов события: "инициализировано"
document.dispatchEvent(
  new CustomEvent("markets.initialized", {
    detail: { markets: window.markets },
  }),
);
